/*!
 * @quasar/quasar-ui-qwindow v1.0.0-beta.7
 * (c) 2020 Jeff Galbraith <jeff@quasar.dev>
 * Released under the MIT License.
 */

(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('vue'), require('quasar')) :
  typeof define === 'function' && define.amd ? define(['exports', 'vue', 'quasar'], factory) :
  (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.QWindow = {}, global.Vue, global.Quasar));
}(this, (function (exports, Vue, quasar) { 'use strict';

  function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

  var Vue__default = /*#__PURE__*/_interopDefaultLegacy(Vue);

  var version = "1.0.0-beta.7";

  /*!
   * q-colorize-mixin v1.0.10
   * (c) 2020 Jeff Galbraith <jeff@quasar.dev>
   * Released under the MIT License.
   */
  var version$1="1.0.10",CSS_COLOR_NAMES=["transparent","aliceblue","antiquewhite","aqua","aquamarine","azure","beige","bisque","black","blanchedalmond","blue","blueviolet","brown","burlywood","cadetblue","chartreuse","chocolate","coral","cornflowerblue","cornsilk","crimson","cyan","darkblue","darkcyan","darkgoldenrod","darkgray","darkgrey","darkgreen","darkkhaki","darkmagenta","darkolivegreen","darkorange","darkorchid","darkred","darksalmon","darkseagreen","darkslateblue","darkslategray","darkslategrey","darkturquoise","darkviolet","deeppink","deepskyblue","dimgray","dimgrey","dodgerblue","firebrick","floralwhite","forestgreen","fuchsia","gainsboro","ghostwhite","gold","goldenrod","gray","grey","green","greenyellow","honeydew","hotpink","indianred","indigo","ivory","khaki","lavender","lavenderblush","lawngreen","lemonchiffon","lightblue","lightcoral","lightcyan","lightgoldenrodyellow","lightgray","lightgrey","lightgreen","lightpink","lightsalmon","lightseagreen","lightskyblue","lightslategray","lightslategrey","lightsteelblue","lightyellow","lime","limegreen","linen","magenta","maroon","mediumaquamarine","mediumblue","mediumorchid","mediumpurple","mediumseagreen","mediumslateblue","mediumspringgreen","mediumturquoise","mediumvioletred","midnightblue","mintcream","mistyrose","moccasin","navajowhite","navy","oldlace","olive","olivedrab","orange","orangered","orchid","palegoldenrod","palegreen","paleturquoise","palevioletred","papayawhip","peachpuff","peru","pink","plum","powderblue","purple","red","rosybrown","royalblue","saddlebrown","salmon","sandybrown","seagreen","seashell","sienna","silver","skyblue","slateblue","slategray","slategrey","snow","springgreen","steelblue","tan","teal","thistle","tomato","turquoise","violet","wheat","white","whitesmoke","yellow","yellowgreen"],QColorizeMixin={name:"QColorizeMixin",props:{color:String},methods:{isNamedCssColor:function(e){return !!e&&CSS_COLOR_NAMES.includes(e.toLowerCase())},isCssColor:function(e){return !!e&&(!!e.match(/^(#|(rgb|hsl)a?\()/)||this.isNamedCssColor(e))},isCssVar:function(e){return !!e&&e.startsWith("--")},calculateColor:function(e,r){return void 0===r&&(r="black"),void 0===e&&void 0!==r?this.calculateColor(r):this.isCssColor(e)?e:this.makeQuasarColorVar(e,r)},makeQuasarColorVar:function(e,r){return "var("+(this.isCssVar(e)?e:"--q-color-"+e)+", '"+r+"')"},isValidCssColor:function(e){return this.isCssColor(e)||this.isCssVar(e)},setBothColors:function(e,r,o){return void 0===o&&(o={}),this.setTextColor(e,this.setBackgroundColor(r,o))},setBackgroundColor:function(e,r){var o;if(void 0===r&&(r={}),this.isValidCssColor(e)){var i=this.calculateColor(e);void 0===r.style&&(r.style={}),r.style=Object.assign({},r.style,{"background-color":""+i});}else if(e){var l=e.toString().trim();void 0===r.class&&(r.class={}),r.class=Object.assign({},r.class,((o={})["bg-"+l]=!0,o));}return r},setTextColor:function(e,r){var o;if(void 0===r&&(r={}),this.isValidCssColor(e)){var i=this.calculateColor(e);void 0===r.style&&(r.style={}),r.style=Object.assign({},r.style,{color:""+i,"caret-color":""+i});}else if(e){var l=e.toString().trim();void 0===r.class&&(r.class={}),r.class=Object.assign({},r.class,((o={})["text-"+l]=!0,o));}return r},setBorderColor:function(e,r){var o;if(void 0===r&&(r={}),this.isValidCssColor(e)){var i=this.calculateColor(e);void 0===r.style&&(r.style={}),r.style=Object.assign({},r.style,{"border-color":""+i});}else if(e){var l=e.toString().trim();void 0===r.class&&(r.class={}),r.class=Object.assign({},r.class,((o={})["border-color-"+l]=!0,o));}return r}}};QColorizeMixin.version=version$1;

  /* eslint-disable no-useless-escape */

  var isSSR = typeof window === 'undefined';
  var fromSSR = false;
  var onSSR = isSSR;

  var iosEmulated = false;
  var iosCorrection;

  function getMatch (userAgent, platformMatch) {
    var match = /(edge|edga|edgios)\/([\w.]+)/.exec(userAgent) ||
      /(opr)[\/]([\w.]+)/.exec(userAgent) ||
      /(vivaldi)[\/]([\w.]+)/.exec(userAgent) ||
      /(chrome|crios)[\/]([\w.]+)/.exec(userAgent) ||
      /(iemobile)[\/]([\w.]+)/.exec(userAgent) ||
      /(version)(applewebkit)[\/]([\w.]+).*(safari)[\/]([\w.]+)/.exec(userAgent) ||
      /(webkit)[\/]([\w.]+).*(version)[\/]([\w.]+).*(safari)[\/]([\w.]+)/.exec(userAgent) ||
      /(firefox|fxios)[\/]([\w.]+)/.exec(userAgent) ||
      /(webkit)[\/]([\w.]+)/.exec(userAgent) ||
      /(opera)(?:.*version|)[\/]([\w.]+)/.exec(userAgent) ||
      /(msie) ([\w.]+)/.exec(userAgent) ||
      (userAgent.indexOf('trident') >= 0 && /(rv)(?::| )([\w.]+)/.exec(userAgent)) ||
      (userAgent.indexOf('compatible') < 0 && /(mozilla)(?:.*? rv:([\w.]+)|)/.exec(userAgent)) ||
      [];

    return {
      browser: match[5] || match[3] || match[1] || '',
      version: match[2] || match[4] || '0',
      versionNumber: match[4] || match[2] || '0',
      platform: platformMatch[0] || ''
    }
  }

  function getPlatformMatch (userAgent) {
    return /(ipad)/.exec(userAgent) ||
      /(ipod)/.exec(userAgent) ||
      /(windows phone)/.exec(userAgent) ||
      /(iphone)/.exec(userAgent) ||
      /(kindle)/.exec(userAgent) ||
      /(silk)/.exec(userAgent) ||
      /(android)/.exec(userAgent) ||
      /(win)/.exec(userAgent) ||
      /(mac)/.exec(userAgent) ||
      /(linux)/.exec(userAgent) ||
      /(cros)/.exec(userAgent) ||
      /(playbook)/.exec(userAgent) ||
      /(bb)/.exec(userAgent) ||
      /(blackberry)/.exec(userAgent) ||
      []
  }

  var hasTouch = isSSR === false
    ? 'ontouchstart' in window || window.navigator.maxTouchPoints > 0
    : false;

  function applyIosCorrection (is) {
    var obj;

    iosCorrection = { is: Object.assign({}, is) };

    delete is.mac;
    delete is.desktop;

    var platform = Math.min(window.innerHeight, window.innerWidth) > 414
      ? 'ipad'
      : 'iphone';

    Object.assign(is, ( obj = {
      mobile: true,
      ios: true,
      platform: platform
    }, obj[ platform ] = true, obj ));
  }

  function getPlatform (UA) {
    var
      userAgent = UA.toLowerCase(),
      platformMatch = getPlatformMatch(userAgent),
      matched = getMatch(userAgent, platformMatch),
      browser = {};

    if (matched.browser) {
      browser[matched.browser] = true;
      browser.version = matched.version;
      browser.versionNumber = parseInt(matched.versionNumber, 10);
    }

    if (matched.platform) {
      browser[matched.platform] = true;
    }

    var knownMobiles = browser.android ||
      browser.ios ||
      browser.bb ||
      browser.blackberry ||
      browser.ipad ||
      browser.iphone ||
      browser.ipod ||
      browser.kindle ||
      browser.playbook ||
      browser.silk ||
      browser['windows phone'];

    // These are all considered mobile platforms, meaning they run a mobile browser
    if (knownMobiles === true || userAgent.indexOf('mobile') > -1) {
      browser.mobile = true;

      if (browser.edga || browser.edgios) {
        browser.edge = true;
        matched.browser = 'edge';
      }
      else if (browser.crios) {
        browser.chrome = true;
        matched.browser = 'chrome';
      }
      else if (browser.fxios) {
        browser.firefox = true;
        matched.browser = 'firefox';
      }
    }
    // If it's not mobile we should consider it's desktop platform, meaning it runs a desktop browser
    // It's a workaround for anonymized user agents
    // (browser.cros || browser.mac || browser.linux || browser.win)
    else {
      browser.desktop = true;
    }

    // Set iOS if on iPod, iPad or iPhone
    if (browser.ipod || browser.ipad || browser.iphone) {
      browser.ios = true;
    }

    if (browser['windows phone']) {
      browser.winphone = true;
      delete browser['windows phone'];
    }

    // Chrome, Opera 15+, Vivaldi and Safari are webkit based browsers
    if (
      browser.chrome ||
      browser.opr ||
      browser.safari ||
      browser.vivaldi ||
      // we expect unknown, non iOS mobile browsers to be webkit based
      (
        browser.mobile === true &&
        browser.ios !== true &&
        knownMobiles !== true
      )
    ) {
      browser.webkit = true;
    }

    // IE11 has a new token so we will assign it msie to avoid breaking changes
    if (browser.rv || browser.iemobile) {
      matched.browser = 'ie';
      browser.ie = true;
    }

    // Blackberry browsers are marked as Safari on BlackBerry
    if (browser.safari && browser.blackberry || browser.bb) {
      matched.browser = 'blackberry';
      browser.blackberry = true;
    }

    // Playbook browsers are marked as Safari on Playbook
    if (browser.safari && browser.playbook) {
      matched.browser = 'playbook';
      browser.playbook = true;
    }

    // Opera 15+ are identified as opr
    if (browser.opr) {
      matched.browser = 'opera';
      browser.opera = true;
    }

    // Stock Android browsers are marked as Safari on Android.
    if (browser.safari && browser.android) {
      matched.browser = 'android';
      browser.android = true;
    }

    // Kindle browsers are marked as Safari on Kindle
    if (browser.safari && browser.kindle) {
      matched.browser = 'kindle';
      browser.kindle = true;
    }

    // Kindle Silk browsers are marked as Safari on Kindle
    if (browser.safari && browser.silk) {
      matched.browser = 'silk';
      browser.silk = true;
    }

    if (browser.vivaldi) {
      matched.browser = 'vivaldi';
      browser.vivaldi = true;
    }

    // Assign the name and platform variable
    browser.name = matched.browser;
    browser.platform = matched.platform;

    if (isSSR === false) {
      if (userAgent.indexOf('electron') > -1) {
        browser.electron = true;
      }
      else if (document.location.href.indexOf('-extension://') > -1) {
        browser.bex = true;
      }
      else {
        if (window.Capacitor !== void 0) {
          browser.capacitor = true;
          browser.nativeMobile = true;
          browser.nativeMobileWrapper = 'capacitor';
        }
        else if (window._cordovaNative !== void 0 || window.cordova !== void 0) {
          browser.cordova = true;
          browser.nativeMobile = true;
          browser.nativeMobileWrapper = 'cordova';
        }

        if (
          hasTouch === true &&
          browser.mac === true &&
          (
            (browser.desktop === true && browser.safari === true) ||
            (
              browser.nativeMobile === true &&
              browser.android !== true &&
              browser.ios !== true &&
              browser.ipad !== true
            )
          )
        ) {
          /*
          * Correction needed for iOS since the default
          * setting on iPad is to request desktop view; if we have
          * touch support and the user agent says it's a
          * desktop, we infer that it's an iPhone/iPad with desktop view
          * so we must fix the false positives
          */
          applyIosCorrection(browser);
        }
      }

      fromSSR = browser.nativeMobile === void 0 &&
        browser.electron === void 0 &&
        document.querySelector('[data-server-rendered]') !== null;

      if (fromSSR === true) {
        onSSR = true;
      }
    }

    return browser
  }

  var userAgent = isSSR !== true
    ? navigator.userAgent || navigator.vendor || window.opera
    : '';

  var ssrClient = {
    has: {
      touch: false,
      webStorage: false
    },
    within: { iframe: false }
  };

  // We export "client" for hydration error-free parts,
  // like touch directives who do not (and must NOT) wait
  // for the client takeover;
  // Do NOT import this directly in your app, unless you really know
  // what you are doing.
  var client = isSSR === false
    ? {
      userAgent: userAgent,
      is: getPlatform(userAgent),
      has: {
        touch: hasTouch,
        webStorage: (function () {
          try {
            if (window.localStorage) {
              return true
            }
          }
          catch (e) {}
          return false
        })()
      },
      within: {
        iframe: window.self !== window.top
      }
    }
    : ssrClient;

  if (isSSR === true) ;
  else {
    iosEmulated = client.is.ios === true &&
      window.navigator.vendor.toLowerCase().indexOf('apple') === -1;
  }

  // using it to manage SSR rendering with best performance

  var canRender = {
    data: function data () {
      return {
        canRender: !onSSR
      }
    },

    mounted: function mounted () {
      this.canRender === false && (this.canRender = true);
    }
  };

  var listenOpts = {
    hasPassive: false,
    passiveCapture: true,
    notPassiveCapture: true
  };

  try {
    var opts = Object.defineProperty({}, 'passive', {
      get: function get () {
        Object.assign(listenOpts, {
          hasPassive: true,
          passive: { passive: true },
          notPassive: { passive: false },
          passiveCapture: { passive: true, capture: true },
          notPassiveCapture: { passive: false, capture: true }
        });
      }
    });
    window.addEventListener('qtest', null, opts);
    window.removeEventListener('qtest', null, opts);
  }
  catch (e) {}

  function prevent (e) {
    e.cancelable !== false && e.preventDefault();
  }

  function stopAndPrevent (e) {
    e.cancelable !== false && e.preventDefault();
    e.stopPropagation();
  }

  // the starting zIndex for floating windows
  var startingZIndex = 4000;

  // maxZIndex is for fullscreen
  // 6000 is $z-fullscreen and $z-menu
  var maxZIndex = 6000 - 100;

  // number of windows registered globally
  var QWindowCount = 0;

  // layered windows
  var layers = {};

  // default starting position
  // relative to viewport for floating
  // relative to document for scroll-with-window
  var defaultX = 20;
  var defaultY = 20;

  var getMousePosition = function (e, type) {
    if ( type === void 0 ) type = 'x';

    if (e.touches !== void 0) {
      if (type === 'x') {
        return e.touches[0].pageX
      }
      return e.touches[0].pageY
    }
    else {
      if (type === 'x') {
        return e.pageX
      }
      return e.pageY
    }
  };

  var getMouseShift = function (e, rect, type) {
    if ( type === void 0 ) type = 'x';

    if (e.touches !== void 0) {
      if (type === 'x') {
        return e.touches[0].clientX - rect.left
      }
      return e.touches[0].clientY - rect.top
    }
    else {
      if (type === 'x') {
        return e.clientX - rect.left
      }
      return e.clientY - rect.top
    }
  };

  var QWindow = {
    name: 'QWindow',

    directives: {
      ClosePopup: quasar.ClosePopup,
      Scroll: quasar.Scroll
    },

    mixins: [QColorizeMixin, canRender],

    props: {
      value: Boolean,
      title: String,
      dense: Boolean,
      embedded: Boolean,
      pinned: Boolean,
      fullscreen: Boolean,
      maximized: Boolean,
      minimized: Boolean,
      noMenu: Boolean,
      noMove: Boolean,
      noResize: Boolean,
      resizable: {
        type: Array,
        default: function () { return [
          'top',
          'left',
          'right',
          'bottom',
          'top-left',
          'top-right',
          'bottom-left',
          'bottom-right'
        ]; }
      },
      scrollWithWindow: {
        type: Boolean,
        default: false
      },
      autoPin: Boolean,

      disabled: Boolean,
      hideToolbarDivider: Boolean,
      hideGrippers: Boolean,
      roundGrippers: Boolean,
      headless: Boolean,
      iconSet: Object,

      backgroundColor: {
        type: String
      },
      gripperBorderColor: {
        type: String
      },
      gripperBackgroundColor: {
        type: String
      },
      borderWidth: {
        type: String,
        default: '1px'
      },
      borderStyle: {
        type: String,
        default: 'solid'
      },

      startX: [Number, String],
      startY: [Number, String],
      width: {
        type: [Number, String],
        default: 400
      },
      height: {
        type: [Number, String],
        default: 400
      },
      actions: {
        type: Array,
        default: function () { return (['pin', 'embedded', 'close']); },
        validator: function (v) { return v.some(function (action) { return [
          'pin',
          'embedded',
          'minimize',
          'maximize',
          'close',
          'fullscreen'].includes(action); }); }
      },
      menuFunc: Function,
      titlebarStyle: [String, Object, Array],
      titlebarClass: [String, Object, Array],
      contentClass: [String, Object, Array],
      contentStyle: [String, Object, Array]
    },

    data: function data () {
      return {
        state: {
          top: 10,
          left: 10,
          bottom: 400,
          right: 400,
          minHeight: 100,
          minWidth: 100,
          shouldDrag: false,
          dragging: false
        },
        restoreState: {
          top: 10,
          left: 10,
          bottom: 400,
          right: 400,
          zIndex: 4000,
          pinned: false,
          embedded: false,
          maximize: false,
          minimize: false
        },
        zIndex: 4000,
        mouseOffsetX: -1,
        mouseOffsetY: -1,
        mousePos: { x: 0, y: 0 },
        scrollX: 0,
        scrollY: 0,
        selected: false,
        fullscreenInitiated: false,
        handles: [
          'top',
          'left',
          'right',
          'bottom',
          'top-left',
          'top-right',
          'bottom-left',
          'bottom-right'
        ],
        stateInfo: {}, // filled in mounted
        iconSetTemplate: { // uses material design icons
          visible: {
            on: {
              icon: 'close',
              label: 'Show'
            },
            off: {
              icon: 'close',
              label: 'Hide'
            }
          },
          embedded: {
            on: {
              icon: 'lock_outline',
              label: 'Embed'
            },
            off: {
              icon: 'lock_open',
              label: 'Float'
            }
          },
          pinned: {
            on: {
              icon: 'location_searching',
              label: 'Pin'
            },
            off: {
              icon: 'gps_fixed',
              label: 'Unpin'
            }
          },
          maximize: {
            on: {
              icon: 'arrow_upward',
              label: 'Maximize'
            },
            off: {
              icon: 'restore',
              label: 'Restore'
            }
          },
          fullscreen: {
            on: {
              icon: 'fullscreen',
              label: 'Enter fullscreen'
            },
            off: {
              icon: 'fullscreen_exit',
              label: 'Leave fullscreen'
            }
          }
        },
        __portal: void 0
      }
    },

    beforeMount: function beforeMount () {
      this.id = ++QWindowCount;
      this.$set(layers, this.id, { window: this });
    },

    beforeDestroy: function beforeDestroy () {
      // just in case
      this.__removeClass(document.body, 'q-window__touch-action');
      this.fullscreenLeave();

      document.removeEventListener('scroll', this.__onScroll, { passive: true });
      document.body.removeEventListener('mousedown', this.__onMouseDownBody, { passive: false });

      this.__destroyPortal();
    },

    mounted: function mounted () {
      this.__updateStateInfo();

      // calculate left starting position
      if (this.startX > 0) {
        this.state.left = this.startX;
      }
      else {
        this.state.left = defaultX * QWindowCount;
      }

      // calculate top starting position
      if (this.startY > 0) {
        this.state.top = this.startY;
      }
      else {
        this.state.top = defaultY * QWindowCount;
      }

      // calculate right and bottom starting positions
      this.state.right = this.state.left + this.width;
      this.state.bottom = this.state.top + this.height;

      // adjust initial user states
      if (this.value !== void 0) {
        if (this.value === true) {
          this.__setStateInfo('visible', true);
        }
        else {
          this.__setStateInfo('visible', false);
        }
      }
      if (this.embedded !== void 0) {
        if (this.embedded === true) {
          this.__setStateInfo('embedded', true);
        }
        else {
          this.__setStateInfo('embedded', false);
        }
      }
      if (this.pinned !== void 0) {
        if (this.pinned === true) {
          if (this.canDo('pinned', true)) {
            this.__setStateInfo('pinned', true);
          }
        }
        else {
          if (this.canDo('pinned', false)) {
            this.__setStateInfo('pinned', false);
          }
        }
      }
      if (this.fullscreen !== void 0) {
        if (this.fullscreen === true) {
          this.fullscreenEnter();
        }
      }
      if (this.maximize !== void 0) {
        if (this.maximize === true && this.__getStateInfo('fullscreen') !== true) {
          this.__setStateInfo('maximize', true);
        }
        else {
          this.__setStateInfo('maximize', false);
        }
      }
      if (this.minimize !== void 0) {
        if (this.minimize === true && this.__getStateInfo('fullscreen') !== true) {
          this.__setStateInfo('minimize', true);
        }
        else {
          this.__setStateInfo('minimize', false);
        }
      }

      // set up scroll handler
      document.addEventListener('scroll', this.__onScroll, { passive: true });
      // set up mousedown on body (so windows can deselect themselves on outside click)
      document.body.addEventListener('mousedown', this.__onMouseDownBody, { passive: false });
    },

    computed: {
      isVisible: function isVisible () {
        return this.__getStateInfo('visible')
      },
      isEmbedded: function isEmbedded () {
        return this.__getStateInfo('embedded')
      },
      isFloating: function isFloating () {
        return this.__getStateInfo('embedded') !== true
      },
      isPinned: function isPinned () {
        return this.__getStateInfo('pinned')
      },
      isFullscreen: function isFullscreen () {
        return this.__getStateInfo('fullscreen')
      },
      isMaximized: function isMaximized () {
        return this.__getStateInfo('maximize')
      },
      isMinimized: function isMinimized () {
        return this.__getStateInfo('minimize')
      },

      isDisabled: function isDisabled () {
        return this.disabled === true
      },

      isEnabled: function isEnabled () {
        return this.isDisabled === false
      },

      isDragging: function isDragging () {
        return this.state.dragging === true
      },

      isSelected: function isSelected () {
        return this.selected === true
      },

      canDrag: function canDrag () {
        return this.isVisible === true &&
          this.isEmbedded !== true &&
          this.isPinned !== true &&
          this.isFullscreen !== true &&
          this.isMaximized !== true &&
          this.isMinimized !== true
      },

      hasStateInfo: function hasStateInfo () {
        return Object.keys(this.stateInfo).length > 0
      },

      __computedVisibility: function __computedVisibility () {
        return this.isVisible === true ? 'visible' : 'hidden'
      },

      computedToolbarHeight: function computedToolbarHeight () {
        return this.headless === true ? 0 : this.dense === true ? 28 : 40
      },

      computedLeft: function computedLeft () {
        return this.state.left
      },

      computedTop: function computedTop () {
        return this.state.top
      },

      computedRight: function computedRight () {
        return this.state.right
      },

      computedBottom: function computedBottom () {
        return this.state.bottom
      },

      computedHeight: function computedHeight () {
        return this.computedBottom - this.computedTop
      },

      computedWidth: function computedWidth () {
        return this.computedRight - this.computedLeft
      },

      computedScrollX: function computedScrollX () {
        return this.computedLeft + (this.scrollWithWindow === false ? this.scrollX : 0)
      },

      computedScrollY: function computedScrollY () {
        return this.computedTop + (this.scrollWithWindow === false ? this.scrollY : 0)
      },

      __computedZIndex: function __computedZIndex () {
        var extra = 0;
        if (this.isDragging) { extra = 100; }
        return this.zIndex + extra
      },

      computedPosition: function computedPosition () {
        return {
          left: this.state.left,
          top: this.state.top,
          width: this.computedWidth,
          height: this.computedHeight,
          scrollX: this.computedScrollX,
          scrollY: this.computedScrollY
        }
      },

      computedActions: function computedActions () {
        // sort and pick ones that are visible based on user selection and state
        var actions = [];
        if (this.actions.includes('embedded') && (this.canDo('embedded', true) || this.canDo('embedded', false))) {
          actions.push('embedded');
        }
        if (this.actions.includes('pin') && (this.canDo('pinned', true) || this.canDo('pinned', false))) {
          actions.push('pinned');
        }
        if (this.actions.includes('fullscreen') && (this.canDo('fullscreen', true) || this.canDo('fullscreen', false))) {
          actions.push('fullscreen');
        }
        if (this.actions.includes('maximize') && (this.canDo('maximize', true) || this.canDo('maximize', false))) {
          actions.push('maximize');
        }
        // if (this.actions.includes('minimize') && (this.canDo('minimize', true) || this.canDo('minimize', false))) {
        //   actions.push('maximize')
        // }
        if (this.actions.includes('close') && this.canDo('close', true)) {
          actions.push('visible');
        }

        return actions
      },

      computedMenuData: function computedMenuData () {
        var this$1 = this;

        // get stateInfo for each menu item
        var menuData = [];
        this.computedActions.map(function (key) {
          if (this$1.stateInfo[key]) {
            menuData.push(Object.assign({}, this$1.stateInfo[key], {key: key}));
          }
        });
        return menuData
      },

      __style: function __style () {
        var style;
        if (this.isMinimized === true) {
          style = {
            position: 'relative',
            visibility: this.__computedVisibility,
            height: this.computedToolbarHeight + 'px',
            borderWidth: '1px',
            borderStyle: 'solid',
            color: this.color,
            backgroundColor: this.backgroundColor,
            minWidth: '100px'
          };
        }
        else if (this.isEmbedded === true) {
          style = {
            position: 'relative',
            visibility: this.__computedVisibility,
            borderWidth: this.borderWidth,
            borderStyle: this.borderStyle,
            width: '100%',
            height: '100%'
          };
        }
        else {
          var top = this.state.top + (this.scrollWithWindow !== true ? this.scrollY : 0);
          var left = this.state.left + (this.scrollWithWindow !== true ? this.scrollX : 0);
          style = {
            position: 'absolute',
            display: 'inline-block',
            borderWidth: this.borderWidth,
            borderStyle: this.borderStyle,
            padding: 0,
            visibility: this.__computedVisibility,
            minWidth: '90px',
            minHeight: '50px',
            top: top + 'px',
            left: left + 'px',
            zIndex: this.__computedZIndex
          };
          if (this.isMaximized) {
            style.width = '100%';
            style.height = '100%';
          }
          else {
            style.width = this.computedWidth + 'px';
            style.height = this.computedHeight + 'px';
          }
        }

        if (this.contentStyle) {
          var type = Object.prototype.toString.call(this.contentStyle);
          if (type === '[object Object]') {
            style = Object.assign({}, style, this.contentStyle);
          }
          else if ((type === '[object Array]')) {
            this.contentStyle.forEach(function (item) {
              style = Object.assign({}, style, item);
            });
          }
          else if (typeof this.contentStyle === 'string') {
            var items = this.contentStyle.split(';');
            items.forEach(function (item) {
              var props = item.split(':');
              style[props[0].trim()] = props[1].trim();
            });
          }
        }

        return style
      },

      __tbStaticClass: function __tbStaticClass () {
        var staticClass = 'q-window__titlebar' +
          (this.hideToolbarDivider !== true ? ' q-window__titlebar--divider' : '') +
          (this.dense === true ? ' q-window__titlebar--dense' : '') +
          (this.isEmbedded !== true && this.isMinimized !== true ? ' absolute' : '') +
          (this.isDragging === true ? ' q-window__touch-action' : '') +
          ' row justify-between items-center';
        return staticClass
      },

      __tbStyle: function __tbStyle () {
        var titleHeight = (this.computedToolbarHeight) + "px";
        var style = { height: titleHeight };

        if (this.titlebarStyle) {
          if (typeof this.titlebarStyle === 'object') {
            style = Object.assign(this.titlebarStyle, style);
          }
          else if (typeof this.titlebarStyle === 'string') {
            style = this.titlebarStyle + '; height:' + titleHeight;
          }
          else if (Array.isArray(this.titlebarStyle)) {
            style = this.titlebarStyle;
            style.push({ height: titleHeight });
          }
        }
        return style
      },

      __bodyStyle: function __bodyStyle () {
        if (this.isEmbedded === true) {
          return {
            height: (this.height - this.computedToolbarHeight) + 'px'
          }
        }
        if (this.isFullscreen === true) {
          return {
            position: 'fixed',
            height: ("calc(100% - " + (this.computedToolbarHeight) + "px"),
            top: this.computedToolbarHeight + 'px'
          }
        }
        return {
          position: 'absolute',
          top: this.computedToolbarHeight + 'px',
          height: this.computedHeight - this.computedToolbarHeight - 2 + 'px'
        }
      },

      __classes: function __classes () {
        return '' +
          (this.isEnabled === true ? ' q-focusable q-hoverable' : ' disabled') +
          (this.isFloating === true && this.isFullscreen !== true ? ' q-window__floating' : '') +
          (this.isFullscreen === true ? ' q-window__fullscreen' : '') +
          (this.isSelected === true && this.isEmbedded !== true && this.isFullscreen !== true ? ' q-window__selected' : '') +
          (this.isDragging === true ? ' q-window__dragging q-window__touch-action' : '')
      }
    },

    watch: {
      value: function value (val) {
        this.stateInfo.visible.state = val;
      },
      iconSet: {
        handler: function handler () {
          this.__updateStateInfo();
        },
        deep: true
      },
      selected: function selected (val) {
        if (this.autoPin === true) {
          if (val === true) {
            this.unpin();
          }
          else {
            this.pin();
          }
        }
        this.$emit('selected', this.selected);
      },
      'stateInfo.visible.state': function stateInfo_visible_state (val) {
        this.$emit('input', val);
      },
      'stateInfo.embedded.state': function stateInfo_embedded_state (val) {
        var this$1 = this;

        if (val !== true) {
          this.__createPortal();
          this.$nextTick(function () {
            this$1.__showPortal();
            this$1.$forceUpdate();
          });
        }
        else {
          this.__hidePortal();
          this.$nextTick(function () {
            this$1.__destroyPortal();
            this$1.$forceUpdate();
          });
        }
      },
      'stateInfo.maximize.state': function stateInfo_maximize_state (val, oldVal) {
        if (oldVal === void 0) {
          // during initialization
          return
        }
        if (val === false) {
          this.__restorePositionAndState();
        }
      },
      'stateInfo.minimize.state': function stateInfo_minimize_state (val, oldVal) {
        if (oldVal === void 0) {
          // during initialization
          return
        }
        if (val === false) {
          this.__restorePositionAndState();
        }
      },
      'stateInfo.fullscreen.state': function stateInfo_fullscreen_state (val, oldVal) {
        if (oldVal === void 0) {
          return
        }
        if (val === true) {
          this.__savePositionAndState();
          this.zIndex = maxZIndex;
        }
        else {
          this.__restorePositionAndState();
          this.fullscreenInitiated = val;
        }
        this.$emit('fullscreen', val);
      },
      '$q.fullscreen.isActive': function $q_fullscreen_isActive (val) {
        if (this.fullscreenInitiated === true) {
          this.__setStateInfo('fullscreen', val);
        }
      },
      '$q.screen.height': function $q_screen_height (val) {
        if (this.isFullscreen === true) {
          this.state.bottom = val;
        }
      },
      '$q.screen.width': function $q_screen_width (val) {
        if (this.isFullscreen === true) {
          this.state.right = val;
        }
      }
    },

    methods: {
      // ------------------------------
      // public methods
      // ------------------------------

      // show the component
      show: function show () {
        if (this.canDo('visible', true)) {
          this.__setStateInfo('visible', true);
          this.$emit('input', true);
          return true
        }
        return false
      },

      // hide the component
      hide: function hide () {
        if (this.canDo('visible', false)) {
          this.__setStateInfo('visible', false);
          this.$emit('input', false);
          return true
        }
        return false
      },

      // embedded
      lock: function lock () {
        if (this.canDo('embedded', true)) {
          this.__setStateInfo('embedded', true);
          this.$emit('embedded', true);
          return true
        }
        return false
      },

      // floating
      unlock: function unlock () {
        if (this.canDo('embedded', false)) {
          this.__setStateInfo('embedded', false);
          this.$emit('embedded', false);
          return true
        }
        return false
      },

      // pinned (can't move or re-size)
      pin: function pin () {
        if (this.canDo('pinned', true)) {
          this.__setStateInfo('pinned', true);
          this.$emit('pinned', true);
          return true
        }
        return false
      },

      // move and resize available, if not embedded
      unpin: function unpin () {
        if (this.canDo('pinned', false)) {
          this.__setStateInfo('pinned', false);
          this.$emit('pinned', false);
          return true
        }
        return false
      },

      maximize: function maximize () {
        var this$1 = this;

        if (this.canDo('maximize', true)) {
          this.bringToFront();
          this.__savePositionAndState();
          this.__setFullWindowPosition();

          this.__setStateInfo('embedded', false);
          this.$nextTick(function () {
            this$1.__setStateInfo('maximize', true);
            this$1.$emit('maximize', true);
          });
          return true
        }
        return false
      },

      minimize: function minimize () {
        if (this.canDo('minimize', true)) {
          this.__savePositionAndState();
          this.__setMinimizePosition();

          this.__setStateInfo('embedded', true);
          this.__setStateInfo('minimize', true);
          this.$emit('minimize', true);
          return true
        }
        return false
      },

      restore: function restore () {
        if (this.__getStateInfo('visible') !== true) {
          // not allowed
          return
        }
        if (this.__getStateInfo('maximize') === true) {
          this.__setStateInfo('maximize', false);
          this.$emit('maximize', false);
        }
        else if (this.__getStateInfo('minimize') === true) {
          this.__setStateInfo('minimize', false);
          this.$emit('minimize', false);
        }
      },

      // go into fullscreen mode
      fullscreenEnter: function fullscreenEnter () {
        if (this.canDo('fullscreen', true)) {
          this.fullscreenInitiated = true;
          this.$q.fullscreen.request();
          return true
        }
        return false
      },

      // leave fullscreen mode
      fullscreenLeave: function fullscreenLeave () {
        if (this.canDo('fullscreen', false)) {
          this.$q.fullscreen.exit();
          return true
        }
        return false
      },

      // toggle fullscreen mode
      toggleFullscreen: function toggleFullscreen () {
        if (this.__getStateInfo('visible') !== true) {
          // not allowed
          return
        }
        this.$q.fullscreen.isActive ? this.fullscreenLeave() : this.fullscreenEnter();
      },

      // bring this window to the front
      bringToFront: function bringToFront () {
        // const sortedLayers = this.__computedSortedLayers
        var sortedLayers = this.__sortedLayers();
        for (var index = 0; index < sortedLayers.length; ++index) {
          var layer = sortedLayers[index];
          layer.zIndex = startingZIndex + index;
        }
        // this window gets highest zIndex
        this.zIndex = startingZIndex + sortedLayers.length;
      },

      // send this window to the back
      sendToBack: function sendToBack () {
        // const sortedLayers = this.__computedSortedLayers
        var sortedLayers = this.__sortedLayers();
        for (var index = 0; index < sortedLayers.length; ++index) {
          var layer = sortedLayers[index];
          layer.zIndex = startingZIndex + index + 1;
        }
        // this window gets lowest zIndex
        this.zIndex = startingZIndex;
      },

      centerWindow: function centerWindow () {
        var w = Math.max(document.documentElement.clientWidth, window.innerWidth || 0);
        var h = Math.max(document.documentElement.clientHeight, window.innerHeight || 0);
        var startX = w / 2 - this.computedWidth / 2;
        var startY = h / 2 - this.computedHeight / 2;
        this.setXY(startX, startY);
      },

      setX: function setX (x) {
        var w = this.computedWidth;
        this.state.left = x;
        this.state.right = this.state.left + w;
      },

      setY: function setY (y) {
        var h = this.computedHeight;
        this.state.top = y;
        this.state.bottom = this.state.top + h;
      },

      setXY: function setXY (x, y) {
        this.setX(x);
        this.setY(y);
      },

      setWidth: function setWidth (width) {
        this.state.right = this.state.left + width;
      },

      setHeight: function setHeight (height) {
        this.state.bottom = this.state.top + height;
      },

      // function that returns true/false if
      // passed in mode/state can be done
      // where state = [true = 'on', false = 'off']
      canDo: function canDo (mode, state) {
        switch (mode) {
          case 'visible':
            if (state === true) {
              if (this.__getStateInfo('visible') !== true) {
                return true
              }
            }
            else {
              if (this.__getStateInfo('visible') === true) {
                return true
              }
            }
            return false

          case 'embedded':
            if (state === true) {
              if (this.__getStateInfo('embedded') !== true &&
                this.__getStateInfo('fullscreen') !== true) {
                return true
              }
            }
            else {
              if (this.__getStateInfo('embedded') === true &&
              this.__getStateInfo('fullscreen') !== true) {
                return true
              }
            }
            return false
          case 'pinned':
            if (state === true) {
              if (this.__getStateInfo('pinned') !== true &&
                this.__getStateInfo('embedded') !== true &&
                this.__getStateInfo('maximize') !== true &&
                this.__getStateInfo('minimize') !== true &&
                this.__getStateInfo('fullscreen') !== true) {
                return true
              }
            }
            else {
              if (this.__getStateInfo('pinned') === true &&
                this.__getStateInfo('embedded') !== true &&
                this.__getStateInfo('maximize') !== true &&
                this.__getStateInfo('minimize') !== true &&
                this.__getStateInfo('fullscreen') !== true) {
                return true
              }
            }
            return false
          case 'maximize':
            if (state === true) {
              if (this.__getStateInfo('maximize') !== true &&
                this.__getStateInfo('embedded') !== true &&
                this.__getStateInfo('minimize') !== true &&
                this.__getStateInfo('fullscreen') !== true) {
                return true
              }
            }
            else {
              if (this.__getStateInfo('maximize') === true &&
                this.__getStateInfo('embedded') !== true &&
                this.__getStateInfo('minimize') !== true &&
                this.__getStateInfo('fullscreen') !== true) {
                return true
              }
            }
            return false
          case 'minimize':
            if (state === true) {
              if (this.__getStateInfo('minimize') !== true &&
                this.__getStateInfo('embedded') !== true &&
                this.__getStateInfo('maximize') !== true &&
                this.__getStateInfo('fullscreen') !== true) {
                return true
              }
            }
            else {
              if (this.__getStateInfo('minimize') === true &&
                this.__getStateInfo('embedded') !== true &&
                this.__getStateInfo('maximize') !== true &&
                this.__getStateInfo('fullscreen') !== true) {
                return true
              }
            }
            return false
          case 'fullscreen':
            if (state === true) {
              if (this.__getStateInfo('fullscreen') !== true &&
              this.__getStateInfo('embedded') !== true) {
                return true
              }
            }
            else {
              if (this.__getStateInfo('fullscreen') === true &&
                this.__getStateInfo('embedded') !== true) {
                return true
              }
            }
            return false
          case 'close':
            if (state === true) {
              if (this.__getStateInfo('embedded') !== true) {
                return true
              }
            }
            else {
              return true
            }
            return false
        }
        console.error(("QWindow unknown mode: " + mode));
      },

      // ------------------------------
      // private methods
      // ------------------------------

      __canBeSelected: function __canBeSelected (x, y) {
        // const sortedLayers = this.__computedSortedLayers
        var sortedLayers = this.__sortedLayers();
        for (var index = sortedLayers.length - 1; index >= 0; --index) {
          if (sortedLayers[index].__portal !== void 0) {
            if (this.__isPointInRect(x, y, sortedLayers[index].__portal.$el)) {
              if (sortedLayers[index].id === this.id) {
                return true
              }
              else {
                return false
              }
            }
          }
        }
        return false
      },

      __isPointInRect: function __isPointInRect (x, y, el) {
        // include gripper size
        var gripperSize = 10;

        var rect = el.getBoundingClientRect();

        return x >= rect.left - gripperSize && x <= rect.left + rect.width + gripperSize &&
          y >= rect.top - gripperSize && y <= rect.top + rect.height + gripperSize
      },

      __sortedLayers: function __sortedLayers () {
        var sortedLayers = [];
        var keys = Object.keys(layers);
        for (var index = 0; index < keys.length; ++index) {
          sortedLayers.push(layers[keys[index]].window);
        }
        function sort (a, b) {
          return a.zIndex < b.zIndex ? -1 : a.zIndex === b.zIndex ? 0 : 1
        }
        sortedLayers.sort(sort);

        return sortedLayers
      },



      __canResize: function __canResize (resizeHandle) {
        var this$1 = this;

        if (this.noResize === true) { return false }
        var missing = this.handles.filter(function (handle) { return !this$1.resizable.includes(handle); });
        return missing.includes(resizeHandle) !== true
      },

      __updateStateInfo: function __updateStateInfo () {
        var stateInfo = {
          visible: {
            state: this.stateInfo.visible !== void 0 && this.stateInfo.visible.state !== void 0 ? this.stateInfo.visible.state : true,
            on: {
              label: this.iconSet !== void 0 && this.iconSet.visible !== void 0 && this.iconSet.visible.on !== void 0 && this.iconSet.visible.on.label !== void 0 ? this.iconSet.visible.on.label : this.iconSetTemplate.visible.on.label,
              icon: this.iconSet !== void 0 && this.iconSet.visible !== void 0 && this.iconSet.visible.on !== void 0 && this.iconSet.visible.on.icon !== void 0 ? this.iconSet.visible.on.icon : this.iconSetTemplate.visible.on.icon,
              func: this.show
            },
            off: {
              label: this.iconSet !== void 0 && this.iconSet.visible !== void 0 && this.iconSet.visible.off !== void 0 && this.iconSet.visible.off.label !== void 0 ? this.iconSet.visible.off.label : this.iconSetTemplate.visible.off.label,
              icon: this.iconSet !== void 0 && this.iconSet.visible !== void 0 && this.iconSet.visible.off !== void 0 && this.iconSet.visible.off.icon !== void 0 ? this.iconSet.visible.off.icon : this.iconSetTemplate.visible.off.icon,
              func: this.hide
            }
          },
          embedded: {
            state: this.stateInfo.embedded !== void 0 && this.stateInfo.embedded.state !== void 0 ? this.stateInfo.embedded.state : true,
            on: {
              label: this.iconSet !== void 0 && this.iconSet.embedded !== void 0 && this.iconSet.embedded.on !== void 0 && this.iconSet.embedded.on.label !== void 0 ? this.iconSet.embedded.on.label : this.iconSetTemplate.embedded.on.label,
              icon: this.iconSet !== void 0 && this.iconSet.embedded !== void 0 && this.iconSet.embedded.on !== void 0 && this.iconSet.embedded.on.icon !== void 0 ? this.iconSet.embedded.on.icon : this.iconSetTemplate.embedded.on.icon,
              func: this.lock
            },
            off: {
              label: this.iconSet !== void 0 && this.iconSet.embedded !== void 0 && this.iconSet.embedded.off !== void 0 && this.iconSet.embedded.off.label !== void 0 ? this.iconSet.embedded.off.label : this.iconSetTemplate.embedded.off.label,
              icon: this.iconSet !== void 0 && this.iconSet.embedded !== void 0 && this.iconSet.embedded.off !== void 0 && this.iconSet.embedded.off.icon !== void 0 ? this.iconSet.embedded.off.icon : this.iconSetTemplate.embedded.off.icon,
              func: this.unlock
            }
          },
          pinned: {
            state: this.stateInfo.pinned !== void 0 && this.stateInfo.pinned.state !== void 0 ? this.stateInfo.pinned.state : false,
            on: {
              label: this.iconSet !== void 0 && this.iconSet.pinned !== void 0 && this.iconSet.pinned.on !== void 0 && this.iconSet.pinned.on.label !== void 0 ? this.iconSet.pinned.on.label : this.iconSetTemplate.pinned.on.label,
              icon: this.iconSet !== void 0 && this.iconSet.pinned !== void 0 && this.iconSet.pinned.on !== void 0 && this.iconSet.pinned.on.icon !== void 0 ? this.iconSet.pinned.on.icon : this.iconSetTemplate.pinned.on.icon,
              func: this.pin
            },
            off: {
              label: this.iconSet !== void 0 && this.iconSet.pinned !== void 0 && this.iconSet.pinned.off !== void 0 && this.iconSet.pinned.off.label !== void 0 ? this.iconSet.pinned.off.label : this.iconSetTemplate.pinned.off.label,
              icon: this.iconSet !== void 0 && this.iconSet.pinned !== void 0 && this.iconSet.pinned.off !== void 0 && this.iconSet.pinned.off.icon !== void 0 ? this.iconSet.pinned.off.icon : this.iconSetTemplate.pinned.off.icon,
              func: this.unpin
            }
          },
          maximize: {
            state: this.stateInfo.maximize !== void 0 && this.stateInfo.maximize.state !== void 0 ? this.stateInfo.maximize.state : false,
            on: {
              label: this.iconSet !== void 0 && this.iconSet.maximize !== void 0 && this.iconSet.maximize.on !== void 0 && this.iconSet.maximize.on.label !== void 0 ? this.iconSet.maximize.on.label : this.iconSetTemplate.maximize.on.label,
              icon: this.iconSet !== void 0 && this.iconSet.maximize !== void 0 && this.iconSet.maximize.on !== void 0 && this.iconSet.maximize.on.icon !== void 0 ? this.iconSet.maximize.on.icon : this.iconSetTemplate.maximize.on.icon,
              func: this.maximize
            },
            off: {
              label: this.iconSet !== void 0 && this.iconSet.maximize !== void 0 && this.iconSet.maximize.off !== void 0 && this.iconSet.maximize.off.label !== void 0 ? this.iconSet.maximize.off.label : this.iconSetTemplate.maximize.off.label,
              icon: this.iconSet !== void 0 && this.iconSet.maximize !== void 0 && this.iconSet.maximize.off !== void 0 && this.iconSet.maximize.off.icon !== void 0 ? this.iconSet.maximize.off.icon : this.iconSetTemplate.maximize.off.icon,
              func: this.restore
            }
          },
          // TODO: commenting out until minimize functionality is completed
          // minimize: {
          //   state: this.stateInfo.minimize !== void 0 && this.stateInfo.minimize.state !== void 0 ? this.stateInfo.minimize.state : false,
          //   on: {
          //     label: this.iconSet !== void 0 && this.iconSet.minimize !== void 0 && this.iconSet.minimize.on !== void 0 && this.iconSet.minimize.on.label !== void 0 ? this.iconSet.minimize.on.label : this.iconSetTemplate.minimize.on.label,
          //     icon: this.iconSet !== void 0 && this.iconSet.minimize !== void 0 && this.iconSet.minimize.on !== void 0 && this.iconSet.minimize.on.icon !== void 0 ? this.iconSet.minimize.on.icon : this.iconSetTemplate.minimize.on.icon,
          //     func: this.minimize
          //   },
          //   off: {
          //     label: this.iconSet !== void 0 && this.iconSet.minimize !== void 0 && this.iconSet.minimize.off !== void 0 && this.iconSet.minimize.off.label !== void 0 ? this.iconSet.minimize.off.label : this.iconSetTemplate.minimize.off.label,
          //     icon: this.iconSet !== void 0 && this.iconSet.minimize !== void 0 && this.iconSet.minimize.off !== void 0 && this.iconSet.minimize.off.icon !== void 0 ? this.iconSet.minimize.off.icon : this.iconSetTemplate.minimize.off.icon,
          //     func: this.restore
          //   }
          // },
          fullscreen: {
            state: this.stateInfo.fullscreen !== void 0 && this.stateInfo.fullscreen.state !== void 0 ? this.stateInfo.fullscreen.state : false,
            on: {
              label: this.iconSet !== void 0 && this.iconSet.fullscreen !== void 0 && this.iconSet.fullscreen.on !== void 0 && this.iconSet.fullscreen.on.label !== void 0 ? this.iconSet.fullscreen.on.label : this.iconSetTemplate.fullscreen.on.label,
              icon: this.iconSet !== void 0 && this.iconSet.fullscreen !== void 0 && this.iconSet.fullscreen.on !== void 0 && this.iconSet.fullscreen.on.icon !== void 0 ? this.iconSet.fullscreen.on.icon : this.iconSetTemplate.fullscreen.on.icon,
              func: this.fullscreenEnter
            },
            off: {
              label: this.iconSet !== void 0 && this.iconSet.fullscreen !== void 0 && this.iconSet.fullscreen.off !== void 0 && this.iconSet.fullscreen.off.label !== void 0 ? this.iconSet.fullscreen.off.label : this.iconSetTemplate.fullscreen.off.label,
              icon: this.iconSet !== void 0 && this.iconSet.fullscreen !== void 0 && this.iconSet.fullscreen.off !== void 0 && this.iconSet.fullscreen.off.icon !== void 0 ? this.iconSet.fullscreen.off.icon : this.iconSetTemplate.fullscreen.off.icon,
              func: this.fullscreenLeave
            }
          }
        };
        this.stateInfo = stateInfo;
      },

      __setStateInfo: function __setStateInfo (id, val) {
        if (id in this.stateInfo) {
          this.stateInfo[id].state = val;
          return true
        }
        return false
      },

      __getStateInfo: function __getStateInfo (id) {
        if (id in this.stateInfo) {
          return this.stateInfo[id].state
        }
        return false
      },

      __setFullWindowPosition: function __setFullWindowPosition () {
        var this$1 = this;

        this.state.top = 0;
        this.state.left = 0;
        this.state.bottom = this.$q.screen.height;
        this.state.right = this.$q.screen.width;
        this.$nextTick(function () {
          this$1.$emit('position', this$1.computedPosition);
        });
      },

      __setMinimizePosition: function __setMinimizePosition () {
        var elements = document.getElementsByClassName('q-notifications__list--bottom');
        if (elements.length > 0) {
          elements[0].appendChild(this.$el);
        }
      },

      __savePositionAndState: function __savePositionAndState () {
        this.restoreState.top = this.state.top;
        this.restoreState.left = this.state.left;
        this.restoreState.bottom = this.state.bottom;
        this.restoreState.right = this.state.right;
        this.restoreState.zIndex = this.__computedZIndex;
        this.restoreState.pinned = this.__getStateInfo('pinned');
        this.restoreState.embedded = this.__getStateInfo('embedded');
        this.restoreState.maximize = this.__getStateInfo('maximize');
        this.restoreState.minimize = this.__getStateInfo('minimize');
      },

      __restorePositionAndState: function __restorePositionAndState () {
        var this$1 = this;

        this.state.top = this.restoreState.top;
        this.state.left = this.restoreState.left;
        this.state.bottom = this.restoreState.bottom;
        this.state.right = this.restoreState.right;
        this.zIndex = this.restoreState.zIndex;
        this.__setStateInfo('pinned', this.restoreState.pinned);
        this.__setStateInfo('embedded', this.restoreState.embedded);
        this.__setStateInfo('maximize', this.restoreState.maximixe);
        this.__setStateInfo('minimize', this.restoreState.minimize);
        this.$nextTick(function () {
          this$1.$emit('position', this$1.computedPosition);
        });
      },

      __addClass: function __addClass (el, name) {
        var arr = el.className.split(' ');
        // make sure it's not already there
        if (arr.indexOf(name) === -1) {
          arr.push(name);
          el.className = arr.join(' ');
        }
      },

      __removeClass: function __removeClass (el, name) {
        var arr = el.className.split(' ');
        var index = arr.indexOf(name);
        if (index !== -1) {
          arr.splice(index, 1);
          el.className = arr.join(' ');
        }
      },

      __onScroll: function __onScroll (e) {
        var this$1 = this;

        if (window !== void 0) {
          this.scrollY = window.pageYOffset;
          this.scrollX = window.pageXOffset;
          if (this.isFloating === true) {
            this.$nextTick(function () {
              this$1.$emit('position', this$1.computedPosition);
            });
          }
        }
      },

      // mousedown for document.body
      __onMouseDownBody: function __onMouseDownBody (e) {
        if (this.isEmbedded) {
          this.state.shouldDrag = this.state.dragging = false;
          return
        }

        // if dragging, already selected
        if (this.state.dragging !== true) {
          var x = getMousePosition(e, 'x');
          var y = getMousePosition(e, 'y');

          this.selected = this.__canBeSelected(x - this.scrollX, y - this.scrollY);
          if (this.selected) {
            this.bringToFront();
          }
        }
      },

      // mousedown for element
      __onMouseDown: function __onMouseDown (e, resizeHandle) {
        this.__removeEventListeners(resizeHandle);

        this.selected = false;
        if (e.touches === void 0 && e.buttons !== 1) {
          return
        }

        if (this.isEmbedded === true) {
          this.state.shouldDrag = this.state.dragging = false;
          return
        }

        var x = getMousePosition(e, 'x');
        var y = getMousePosition(e, 'y');

        //  can window be selected
        this.selected = this.__canBeSelected(x - this.scrollX, y - this.scrollY);
        if (!this.selected) {
          return
        }

        // bring window to front
        this.bringToFront();


        this.resizeHandle = resizeHandle;
        // this.selected = true

        // save mouse position
        this.mousePos.x = x;
        this.mousePos.y = y;

        var rect = this.__portal.$el.getBoundingClientRect();
        this.shiftX = getMouseShift(e, rect, 'x');
        this.shiftY = getMouseShift(e, rect, 'y');

        // save existing position information
        this.tmpTop = this.state.top;
        this.tmpLeft = this.state.left;
        this.tmpRight = this.state.right;
        this.tmpBottom = this.state.bottom;
        this.tmpHeight = this.tmpBottom - this.tmpTop;
        this.tmpWidth = this.tmpRight - this.tmpLeft;

        this.state.shouldDrag = true;

        this.__addEventListeners();
        if (e.touches !== void 0) {
          this.__addClass(document.body, 'q-window__touch-action');
        }

        // stopAndPrevent(e)
        prevent(e);
      },

      __addEventListeners: function __addEventListeners () {
        document.body.addEventListener('mousemove', this.__onMouseMove, { capture: true });
        document.body.addEventListener('mouseup', this.__onMouseUp, { capture: true });
        document.body.addEventListener('keyup', this.__onKeyUp, { capture: true });
      },

      __removeEventListeners: function __removeEventListeners () {
        document.body.removeEventListener('mousemove', this.__onMouseMove, { capture: true });
        document.body.removeEventListener('mouseup', this.__onMouseUp, { capture: true });
        document.body.removeEventListener('keyup', this.__onKeyUp, { capture: true });
      },

      __onKeyUp: function __onKeyUp (e) {
        var this$1 = this;

        // if ESC key
        if (e.keyCode === 27 && this.isDragging === true) {
          prevent(e);
          this.__removeEventListeners();
          this.state.shouldDrag = this.state.dragging = false;
          this.state.top = this.tmpTop;
          this.state.left = this.tmpLeft;
          this.state.right = this.tmpRight;
          this.state.bottom = this.tmpBottom;
          this.$nextTick(function () {
            this$1.$emit('canceled', this$1.computedPosition);
          });
        }
      },

      __onMouseMove: function __onMouseMove (e, resizeHandle) {
        var this$1 = this;

        if (this.state.shouldDrag !== true || (e.touches === void 0 && e.buttons !== 1)) {
          this.__removeEventListeners();
          return
        }

        var mouseX = getMousePosition(e, 'x');
        var mouseY = getMousePosition(e, 'y');

        // wait 3 pixel move to initiate drag
        if (this.state.dragging !== true) {
          if (Math.abs(this.mousePos.x - mouseX) >= 3 || Math.abs(this.mousePos.y - mouseY) >= 3) {
            this.state.dragging = true;
            this.$emit('beforeDrag', e);
          }
          else {
            return
          }
        }

        switch (resizeHandle || this.resizeHandle) {
          case 'top':
            this.state.top = mouseY - window.pageYOffset - this.shiftY;
            this.$nextTick(function () {
              if (this$1.computedHeight < this$1.state.minHeight) {
                this$1.state.top = this$1.tmpBottom - this$1.state.minHeight;
              }
            });
            break
          case 'left':
            this.state.left = mouseX - window.pageXOffset - this.shiftX;
            this.$nextTick(function () {
              if (this$1.computedWidth < this$1.state.minWidth) {
                this$1.state.left = this$1.tmpRight - this$1.state.minWidth;
              }
            });
            break
          case 'right':
            this.state.right = mouseX - window.pageXOffset;
            this.$nextTick(function () {
              if (this$1.computedWidth < this$1.state.minWidth) {
                this$1.state.right = this$1.tmpLeft - this$1.state.minWidth;
              }
            });
            break
          case 'bottom':
            this.state.bottom = mouseY - window.pageYOffset;
            this.$nextTick(function () {
              if (this$1.computedHeight < this$1.state.minHeight) {
                this$1.state.bottom = this$1.tmpTop - this$1.state.minHeight;
              }
            });
            break
          case 'top-left':
            this.__onMouseMove(e, 'top');
            this.__onMouseMove(e, 'left');
            return
          case 'top-right':
            this.__onMouseMove(e, 'top');
            this.__onMouseMove(e, 'right');
            return
          case 'bottom-left':
            this.__onMouseMove(e, 'bottom');
            this.__onMouseMove(e, 'left');
            return
          case 'bottom-right':
            this.__onMouseMove(e, 'bottom');
            this.__onMouseMove(e, 'right');
            return
          case 'titlebar':
            if (this.scrollWithWindow === true) {
              this.state.top = mouseY - this.shiftY;
              this.state.left = mouseX - this.shiftX;
            }
            else {
              this.state.top = mouseY - window.pageYOffset - this.shiftY;
              this.state.left = mouseX - window.pageXOffset - this.shiftX;
            }
            this.state.bottom = this.state.top + this.tmpHeight;
            this.state.right = this.state.left + this.tmpWidth;
            break
        }

        stopAndPrevent(e);
      },

      __onMouseUp: function __onMouseUp (e) {
        if (this.state.dragging === true) {
          prevent(e);
          this.__removeEventListeners();
          if (e.touches !== void 0) {
            this.__removeClass(document.body, 'q-window__touch-action');
          }
          this.state.shouldDrag = this.state.dragging = false;
          this.$emit('afterDrag', e);
          this.$emit('position', this.computedPosition);
        }
      },

      __onTouchMove: function __onTouchMove (e, resizeHandle) {
        stopAndPrevent(e);
        this.resizeHandle = resizeHandle;
        // let touchY = e.touches[0].pageY
        // let touchYDelta = touchY - (this.lastTouchY ? this.lastTouchY : 0)
        // if (window.pageYOffset === 0) {
        //   // to supress pull-to-refresh preventDefault
        //   // on the overscrolling touchmove when
        //   // window.pageYOffset === 0
        //   if (touchYDelta > 0) {
        //     prevent(e)
        //   }
        // }

        this.__onMouseMove(e);
      },

      __onTouchStart: function __onTouchStart (e, resizeHandle) {
        stopAndPrevent(e);
        this.__onMouseDown(e, resizeHandle);
      },

      __onTouchEnd: function __onTouchEnd (e, resizeHandle) {
        stopAndPrevent(e);
        this.resizeHandle = resizeHandle;
        this.__onMouseUp(e);
      },

      __renderMoreItem: function __renderMoreItem (h, stateInfo) {
        if (stateInfo === void 0) {
          return ''
        }

        if (typeof stateInfo === 'string' && stateInfo === 'separator') {
          return h(quasar.QSeparator)
        }

        return h(quasar.QItem, {
          attrs: {
            key: stateInfo.key
          },
          directives: [
            {
              name: 'close-popup',
              value: true
            }
          ],
          props: {
            clickable: true,
            dense: this.dense
          },
          on: {
            click: function () { return (stateInfo.state === true ? stateInfo.off.func() : stateInfo.on.func()); }
          }
        }, [
          h(quasar.QItemSection, {
            props: {
              noWrap: true
            }
          }, stateInfo.state === true ? stateInfo.off.label : stateInfo.on.label),
          h(quasar.QItemSection, {
            props: {
              avatar: true
            }
          }, [
            h(quasar.QIcon, {
              props: {
                name: stateInfo.state === true ? stateInfo.off.icon : stateInfo.on.icon
              }
            })
          ])
        ])
      },

      __renderMoreItems: function __renderMoreItems (h, menuData) {
        var this$1 = this;

        return menuData.map(function (stateInfo) { return this$1.__renderMoreItem(h, stateInfo); })
      },

      __renderMoreMenu: function __renderMoreMenu (h, menuData) {
        // these two issues happen during early render
        if (this.computedActions.length === 0) {
          return ''
        }
        if (this.hasStateInfo !== true) {
          return ''
        }

        // let user manipulate menu
        if (this.menuFunc) {
          this.menuFunc(menuData);
        }

        return h(quasar.QMenu, [
          h(quasar.QList, this.setBothColors(this.color, this.backgroundColor, {
            props: {
              highlight: true,
              dense: true
            },
            style: {
              zIndex: (this.isEmbedded === true) ? void 0 : this.__computedZIndex + 1
            }
          }), [].concat( this.__renderMoreItems(h, menuData) ))
        ])
      },

      __renderMoreButton: function __renderMoreButton (h, menuData) {
        if (this.noMenu === true) {
          return ''
        }

        return h(quasar.QBtn, {
          staticClass: 'q-window__titlebar--actions',
          props: {
            flat: true,
            round: true,
            dense: true,
            icon: 'more_vert'
          }
        }, [
          this.__renderMoreMenu(h, menuData)
        ])
      },

      __renderTitle: function __renderTitle (h) {
        return h('div', {
          staticClass: 'q-window__title col ellipsis'
        }, this.title)
      },

      __renderTitlebar: function __renderTitlebar (h, menuData) {
        if (this.headless === true) {
          return ''
        }

        var titlebarSlot = this.$scopedSlots.titlebar;

        return h('div', {
          staticClass: this.__tbStaticClass,
          class: this.titlebarClass,
          style: this.__tbStyle
        }, [
          titlebarSlot === void 0 ? this.__renderTitle(h) : '',
          titlebarSlot === void 0 ? this.__renderMoreButton(h, menuData) : '',
          titlebarSlot !== void 0 ? titlebarSlot(menuData) : '',
          (this.canDrag === true) &&
            this.__renderResizeHandle(h, 'titlebar', this.noMenu ? 0 : 35) // width of more button
        ])
      },

      // grippers can visibly be seen
      __renderGripper: function __renderGripper (h, resizeHandle) {
        var this$1 = this;

        if (this.__canResize(resizeHandle) === false) {
          return ''
        }
        var staticClass = 'gripper gripper-' + resizeHandle + (this.roundGrippers === true ? ' gripper-round' : '');
        return h('div', this.setBorderColor(this.gripperBorderColor, this.setBackgroundColor(this.gripperBackgroundColor, {
          ref: resizeHandle,
          staticClass: staticClass,
          on: {
            mousedown: function (e) { return this$1.__onMouseDown(e, resizeHandle); },
            touchstart: function (e) { return this$1.__onTouchStart(e, resizeHandle); },
            touchmove: function (e) { return this$1.__onTouchMove(e, resizeHandle); },
            touchend: function (e) { return this$1.__onTouchEnd(e, resizeHandle); }
          }
        })))
      },

      // resize handles are for when there are no grippers
      __renderResizeHandle: function __renderResizeHandle (h, resizeHandle, actionsWidth) {
        var this$1 = this;

        if (this.noMove && resizeHandle === 'titlebar') {
          return ''
        }
        if (resizeHandle !== 'titlebar' && this.__canResize(resizeHandle) === false) {
          return ''
        }
        var staticClass = 'q-window__resize-handle ' + 'q-window__resize-handle--' + resizeHandle;
        var width = this.computedWidth;
        var style = {};
        if (actionsWidth && actionsWidth > 0 && this.canDrag === true) {
          width -= actionsWidth;
          style.width = width + 'px';
        }
        return h('div', {
          ref: resizeHandle,
          staticClass: staticClass,
          style: style,
          on: {
            mousedown: function (e) { return this$1.__onMouseDown(e, resizeHandle); },
            touchstart: function (e) { return this$1.__onTouchStart(e, resizeHandle); },
            touchmove: function (e) { return this$1.__onTouchMove(e, resizeHandle); },
            touchend: function (e) { return this$1.__onTouchEnd(e, resizeHandle); }
          }
        })
      },

      __renderGrippers: function __renderGrippers (h) {
        var this$1 = this;

        if (this.hideGrippers === true) {
          return ''
        }
        return this.handles.map(function (resizeHandle) { return this$1.__renderGripper(h, resizeHandle); })
      },

      __renderResizeHandles: function __renderResizeHandles (h) {
        var this$1 = this;

        if (this.hideGrippers !== true) {
          return ''
        }
        return this.handles.map(function (resizeHandle) { return this$1.__renderResizeHandle(h, resizeHandle); })
      },

      __renderBody: function __renderBody (h) {
        var defaultScopedSlot = this.$scopedSlots.default;
        var defaultSlot = this.$slots.default;
        return h('div', {
          staticClass: 'q-window__body row',
          style: this.__bodyStyle
        }, [
          defaultSlot || defaultScopedSlot ? defaultScopedSlot({ zIndex: this.zIndex }) : '',
          (this.headless === true && this.canDrag === true) &&
            this.__renderResizeHandle(h, 'titlebar', this.noMenu ? 0 : 44) // width of more button

        ])
      },

      __render: function __render (h) {
        // get stateInfo for each menu item
        var menuData = [].concat( this.computedMenuData );

        return h('div', this.setBothColors(this.color, this.backgroundColor, {
          staticClass: 'q-window ' + this.__classes,
          class: this.contentClass,
          style: this.__style
        }), [
          (this.canDrag === true) && [].concat( this.__renderResizeHandles(h) ),
          (this.canDrag === true) && [].concat( this.__renderGrippers(h) ),
          this.__renderTitlebar(h, menuData),
          this.isMinimized !== true && this.__renderBody(h)
        ])
      },

      __createPortal: function __createPortal () {
        var this$1 = this;

        var obj = {
          name: 'QWindowPortal',
          parent: this,

          inheritAttrs: false,

          render: function (h) { return this$1.__render(h); },

          components: this.$options.components,
          directives: this.$options.directives
        };

        this.__portal = new Vue__default['default'](obj).$mount();
      },

      __destroyPortal: function __destroyPortal () {
        if (this.__portal) {
          this.__portal.$destroy();
          this.__portal.$el.remove();
          this.__portal = void 0;
        }
      },

      __showPortal: function __showPortal () {
        if (this.__portal !== void 0 && this.__portal.showing !== true) {
          var app = document.getElementById('q-app');
          if (app) {
            app.appendChild(this.__portal.$el);
          }
          else {
            document.body.appendChild(this.__portal.$el);
          }
          this.__portal.showing = true;
        }
      },

      __hidePortal: function __hidePortal () {
        if (this.__portal !== void 0 && this.__portal.showing === true) {
          this.__portal.$el.remove();
          this.__portal.showing = false;
        }
      }
    },

    render: function render (h) {
      if (this.__portal === void 0) {
        return this.__render(h)
      }
      return ''
    }
  };

  var Plugin = {
    version: version,
    QWindow: QWindow,

    install: function install (Vue) {
      Vue.component(QWindow.name, QWindow);
    }
  };

  Vue__default['default'].use(Plugin);

  exports.QWindow = QWindow;
  exports.version = version;

  Object.defineProperty(exports, '__esModule', { value: true });

})));
